// created on 10/02/2005 at 20:19
using Gtk;
using Gdk;
using System;
using System.IO;

public class CheezeFileOpenDialog : Gtk.FileSelection{
	private CheezePadWindow parent_window;	

	public CheezeFileOpenDialog(CheezePadWindow parent,string t):base(t){
		parent_window = parent;
	    OkButton.Clicked += new EventHandler (file_open);
		CancelButton.Clicked += new EventHandler (open_file_dialog_close);
		DeleteEvent += new DeleteEventHandler (open_file_dialog_destroy);
		//this.ShowAll();
		this.Run();
	}
	
	void file_open(object o, EventArgs args){
		Console.WriteLine("Opening {0}",Filename);
		StreamReader open_file = new System.IO.StreamReader(Filename);
		string open_file_path = Filename;
		Title = "Cheezepad "+Filename;
		String cont = "";	
		String c; 
		bool firstline=true;
		while((c = open_file.ReadLine())!=null){
			if(!firstline)
				cont = String.Concat(cont,"\n",c);
			else{
				cont = c;
				firstline=false;
			}
		}	
		open_file.Close();
		parent_window.texty.Buffer.Text = "";
		CheezeSaver.Deserialize(parent_window.texty.Buffer,cont);
		this.Destroy();	
	}
	
	void open_file_dialog_close(object o, EventArgs args){
		this.Destroy();	
	}
	
	void open_file_dialog_destroy(object o, DeleteEventArgs args){
		this.Destroy();
	}
}