// created on 10/02/2005 at 20:34
using Gtk;
using Gdk;
using System;
using System.IO;

public class CheezeFileSaveDialog : Gtk.FileSelection{
	private CheezePadWindow parent_window;	

	public CheezeFileSaveDialog(CheezePadWindow parent,string t):base(t){
		parent_window = parent;
	    OkButton.Clicked += new EventHandler (file_save);
		CancelButton.Clicked += new EventHandler (save_file_dialog_close);
		DeleteEvent += new DeleteEventHandler (save_file_dialog_destroy);
		//this.ShowAll();
		this.Run();
	}
	
	void file_save(object o, EventArgs args){
		
		String cont = CheezeSaver.Serialize(parent_window.texty.Buffer);
		StreamWriter save_file = new System.IO.StreamWriter(Filename);
		parent_window.Title = "Cheezepad "+Filename;
		save_file.Write(cont);
		save_file.Flush();
		save_file.Close();
		Console.WriteLine("Saving {0}",Filename);
		this.Destroy();
	}
	
	void save_file_dialog_close(object o, EventArgs args){
		this.Destroy();
	}
	
	void save_file_dialog_destroy(object o, DeleteEventArgs args){
		this.Destroy();
	}
	
}