// created on 10/02/2005 at 18:55
using Gtk;
using Gdk;
using System;
public class CheezeToolbar : Gtk.Toolbar{
	public CheezePadWindow parent_window;	
	Gtk.AccelGroup accel_group;
	Gtk.ToggleButton bold;
	Gtk.ToggleButton italic;
	Gtk.ToggleButton underline;
	Gtk.ToggleButton left;
	Gtk.ToggleButton center;
	Gtk.ToggleButton right;

	public CheezeToolbar(CheezePadWindow attached,AccelGroup accel) : base() {
		
		System.Console.WriteLine("Reaching Toolbar COnstructor");
		parent_window = attached;
	    accel_group = accel;
		ToolbarStyle = ToolbarStyle.Icons;
		Orientation = Orientation.Horizontal;
		//new cutcopypaste
		AppendItem("New","New","New",
			       new Gtk.Image(Stock.New,IconSize.SmallToolbar), 
			       new SignalFunc (new_btn_clicked));
		AppendItem("Open","Open","Open",
			       new Gtk.Image(Stock.Open,IconSize.SmallToolbar), 
			       new SignalFunc (open_btn_clicked));
		AppendItem("Save","Save","Save",
			       new Gtk.Image(Stock.Save,IconSize.SmallToolbar), 
			       new SignalFunc (save_btn_clicked));
		AppendItem("Cut","Cut","Cut",
			       new Gtk.Image(Stock.Cut,IconSize.SmallToolbar), 
			       new SignalFunc (cut_btn_clicked));
		AppendItem("Copy","Copy","Copy",
			       new Gtk.Image(Stock.Copy,IconSize.SmallToolbar), 
			       new SignalFunc (copy_btn_clicked));
		AppendItem("Paste","Paste","Paste",
			       new Gtk.Image(Stock.Paste,IconSize.SmallToolbar), 
			       new SignalFunc (paste_btn_clicked));
		AppendSpace();	
	
	
		bold = new Gtk.ToggleButton(Mono.Unix.Catalog.GetString("bold"));
		bold.Remove(((Gtk.Widget) bold.Child));
		bold.Add(new Gtk.Image(Stock.Bold,IconSize.LargeToolbar));
		bold.Data[0] = "Style:bold";
		bold.Toggled += new EventHandler(style_btn_clicked);
		bold.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.b,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
        Add(bold);
		italic = new Gtk.ToggleButton(Mono.Unix.Catalog.GetString("italic"));
		italic.Remove(((Gtk.Widget) italic.Child));
		italic.Add(new Gtk.Image(Stock.Italic,IconSize.LargeToolbar));
		italic.Data[0] = "Style:italic";
		italic.Toggled += new EventHandler(style_btn_clicked);
		italic.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.i,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
        Add(italic);
		underline = new Gtk.ToggleButton(Mono.Unix.Catalog.GetString("underline"));
		underline.Remove(((Gtk.Widget) underline.Child));
		underline.Add(new Gtk.Image(Stock.Underline,IconSize.LargeToolbar));
		underline.Data[0] = "Style:underline";
		underline.Toggled += new EventHandler(style_btn_clicked);
		underline.AddAccelerator("activate",
                                accel_group,
                                (uint) Gdk.Key.u,
                                Gdk.ModifierType.ControlMask,
                                Gtk.AccelFlags.Visible);
        Add(underline);

		AppendSpace();	
	left = new Gtk.RadioButton(Mono.Unix.Catalog.GetString("_Left Justify"));
	((ToggleButton) left).DrawIndicator=false;
	left.Remove(((Gtk.Widget) left.Child));
	left.Add(new Gtk.Image(Stock.JustifyLeft,IconSize.LargeToolbar));
	left.Data[0] = "Justify:left";
	left.Toggled += new EventHandler(justify_style_btn_clicked);
	left.AddAccelerator("activate",
                           accel_group,
                           (uint) Gdk.Key.l,
                           Gdk.ModifierType.ControlMask,
                           Gtk.AccelFlags.Visible);
    Add(left);
    center = new Gtk.RadioButton((RadioButton)left,Mono.Unix.Catalog.GetString("C_enter Justify"));
    ((ToggleButton) center).DrawIndicator=false;
	center.Remove(((Gtk.Widget) center.Child));
	center.Add(new Gtk.Image(Stock.JustifyCenter,IconSize.LargeToolbar));
	center.Data[0] = "Justify:center";
	center.Toggled += new EventHandler(justify_style_btn_clicked);
	center.AddAccelerator("activate",
                           accel_group,
                           (uint) Gdk.Key.e,
                           Gdk.ModifierType.ControlMask,
                           Gtk.AccelFlags.Visible);
    Add(center);
	right = new Gtk.RadioButton((RadioButton)center,Mono.Unix.Catalog.GetString("_Right Justify"));
	((ToggleButton) right).DrawIndicator=false;
	right.Remove(((Gtk.Widget) right.Child));
	right.Add(new Gtk.Image(Stock.JustifyRight,IconSize.LargeToolbar));
	right.Data[0] = "Justify:right";
	right.Toggled += new EventHandler(justify_style_btn_clicked);
	right.AddAccelerator("activate",
                           accel_group,
                           (uint) Gdk.Key.r,
                           Gdk.ModifierType.ControlMask,
                           Gtk.AccelFlags.Visible);
   Add(right);
		
	
/*		AppendItem("Left","Left","Left",
			       new Gtk.Image(Stock.JustifyLeft,IconSize.SmallToolbar), 
			       new SignalFunc (left_btn_clicked));
		AppendItem("Center","Center","Center",
			       new Gtk.Image(Stock.JustifyCenter,IconSize.SmallToolbar), 
			       new SignalFunc (center_btn_clicked));
		AppendItem("Right","Right","Right",
			       new Gtk.Image(Stock.JustifyRight,IconSize.SmallToolbar), 
			       new SignalFunc (right_btn_clicked));
*/
		AppendItem("Foreground","Change the Current Foreground Color","Change the Current Foreground Color",
			       new Gtk.Image(Stock.SelectColor,IconSize.SmallToolbar), 
			       new SignalFunc (fg_color_btn_clicked));
		AppendItem("Foreground","Change the Current Background Color","Change the Current Background Color",
			       new Gtk.Image(Stock.SelectColor,IconSize.SmallToolbar), 
			       new SignalFunc (bg_color_btn_clicked));
	}
	
	void style_btn_clicked(object o, EventArgs args){
		Gtk.Widget thing = (Gtk.Widget) o;
		string tag = (string) thing.Data[0];
		parent_window.Focus = ((Gtk.Widget) parent_window.texty);
		if(tag!=null)
			((CheezeBuffer) parent_window.texty.Buffer).toggle_tag_active(tag);
	}
	
	void justify_style_btn_clicked(object o, EventArgs args){
		Gtk.Widget thing = (Gtk.Widget) o;
		string tag = (string) thing.Data[0];
		parent_window.Focus = ((Gtk.Widget) parent_window.texty);
		if(tag!=null){
			((CheezeBuffer) parent_window.texty.Buffer).remove_tag_class_from_line("Justify");
			((CheezeBuffer) parent_window.texty.Buffer).apply_tag_to_line(tag);
		}
	}
	
	void new_btn_clicked()
	{
		new CheezePadWindow(CheezePadWindow.NEWDOCSTRING,null);
	}

	void new_btn_clicked(object o, EventArgs args)
	{
		new CheezePadWindow(CheezePadWindow.NEWDOCSTRING,null);
	}

	
		
	void open_btn_clicked(){
		CheezeFileOpenDialog open_new_file = new CheezeFileOpenDialog(parent_window,"Open File...");
	}
	
	void fg_color_btn_clicked(){
		CheezeColorSelectionDialog colorpicker = new CheezeColorSelectionDialog(parent_window,true,"Select New Foreground Color");
	}

	void bg_color_btn_clicked(){
		CheezeColorSelectionDialog colorpicker = new CheezeColorSelectionDialog(parent_window,false,"Select New Background Color");
	}	
	
	void save_btn_clicked(){
		CheezeFileSaveDialog save_file = new CheezeFileSaveDialog(parent_window,"Save File...");
	}

	void cut_btn_clicked(){
		parent_window.texty.Buffer.CutClipboard(Clipboard.Get(Gdk.Selection.Clipboard),true);
	}
	
	void copy_btn_clicked(){
		parent_window.texty.Buffer.CopyClipboard(Clipboard.Get (Gdk.Selection.Clipboard));
	}
								
	void paste_btn_clicked(){
		((CheezeBuffer) parent_window.texty.Buffer).active_tags.Clear();
		parent_window.texty.Buffer.PasteClipboard(Clipboard.Get (Gdk.Selection.Clipboard));
	}
	

	
	

}
